Index: cpp/frams/genetics/f4/f4_oper.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_oper.cpp	(revision 1226)
+++ cpp/frams/genetics/f4/f4_oper.cpp	(revision 1227)
@@ -730,22 +707,36 @@
 	}
 	uint32_t style = GENSTYLE_CS(0, GENSTYLE_STRIKEOUT); //default, should be changed below
-	if (strchr("X ", ch))                    style = GENSTYLE_CS(0, GENSTYLE_NONE);
-	else if (strchr("N", ch))                style = GENSTYLE_RGBS(0, 200, 0, GENSTYLE_NONE);
+	if (strchr("X", ch))                     style = GENSTYLE_CS(0, GENSTYLE_BOLD);
+	else if (strchr(":", ch))                style = GENSTYLE_CS(0, GENSTYLE_NONE);
+	else if (strchr("#", ch))                style = GENSTYLE_RGBS(220, 0, 0, GENSTYLE_BOLD);
+	else if (strchr("/=!", ch))              style = GENSTYLE_RGBS(255, 140, 0, GENSTYLE_BOLD); //property... for now, f4 does not supoprt properties in general for any neuron class, like f1 does
+	else if (strchr("N@|*", ch))             style = GENSTYLE_RGBS(150, 0, 150, GENSTYLE_BOLD); //neuroclass
 	else if (strchr("<", ch))                style = GENSTYLE_RGBS(0, 0, 200, GENSTYLE_BOLD);
 	else if (strchr(">", ch))                style = GENSTYLE_RGBS(0, 0, 100, GENSTYLE_NONE);
-	else if (strchr(STYL4CAT_DIGIT, ch))     style = GENSTYLE_RGBS(100, 100, 100, GENSTYLE_NONE);
+	else if (strchr(STYL4CAT_DIGIT, ch))     style = GENSTYLE_CS(GENCOLOR_NUMBER, GENSTYLE_NONE);
 	else if (strchr(STYL4CAT_MODIFIC, ch))   style = GENSTYLE_RGBS(100, 100, 100, GENSTYLE_NONE);
 	else if (strchr(STYL4CAT_NEUMOD, ch))    style = GENSTYLE_RGBS(0, 150, 0, GENSTYLE_NONE);
-	if (isalpha(ch) || strchr(STYL4CAT_NEUSPECIAL, ch))
-	{
+	if (isalpha(ch))
+	{
+		// allowed neuron formats:
+		//   N:CLASSNAME
+		//   N:@
+		//   N:|
+		// old syntax still supported in coloring, but no longer valid:
+		//   [SENSOR, WEIGHT]
+		//   N@
+		//   N|
+		// ...so must have N: or [ before neuroclass name (or just N, but this is handled above - for N@|* only)
+
 		while (pos > 0)
 		{
 			pos--;
-			if (!(isalpha(g[pos]) || strchr(STYL4CAT_NEUSPECIAL, ch)))
-			{
-				if (isupper(g[pos + 1]) && (g[pos] == ':' || g[pos] == '[')) // name of neuron class
-					style = GENSTYLE_RGBS(150, 0, 150, GENSTYLE_ITALIC);
-				else // property
-					style = GENSTYLE_RGBS(100, 100, 100, GENSTYLE_NONE);
+			if (!isalpha(g[pos]))
+			{
+				if (isupper(g[pos + 1]) && (g[pos] == '[') || (g[pos] == ':' && pos > 0 && g[pos - 1] == 'N')) //we may have sequences like :-/:I (even though they are not valid) - in this example "I" should not be treated as neuron name, hence there must also be a "N" before ":"
+					style = GENSTYLE_RGBS(150, 0, 150, GENSTYLE_BOLD); // neuroclass
+				//(...) else (...)
+				//	style = GENSTYLE_RGBS(255, 140, 0, GENSTYLE_BOLD); // property - current f4 does not support neuron properties in a general case, only those old-style "/=!" as +! -! += -= +/ -/
+				break;
 			}
 		}
Index: cpp/frams/genetics/f4/f4_oper.h
===================================================================
--- cpp/frams/genetics/f4/f4_oper.h	(revision 1226)
+++ cpp/frams/genetics/f4/f4_oper.h	(revision 1227)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2017  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2023  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -33,4 +33,11 @@
 //@}
 
+/** @name Codes for specific F4_MOD neuron mutation subtypes (not included in mutation_method_names, all are considered F4_MOD there) */
+//@{
+#define F4_MODNEU_CONN     0
+#define F4_MODNEU_WEIGHT   1
+#define F4_MODNEU_COUNT    2
+//@}
+
 class Geno_f4 : public GenoOperators
 {
@@ -48,5 +55,7 @@
 	// mutation probabilities
 	double prob[F4_COUNT];            ///<relative probabilities of selecting mutation types in f4 genotype
-	double probadd[F4_ADD_COUNT];     ///<relative probabilities of selecting mutation addition subtypes
+	double probadd[F4_ADD_COUNT];     ///<relative probabilities of selecting addition mutation subtypes
+	double probmodneu[F4_MODNEU_COUNT];     ///<relative probabilities of selecting neuron mutation subtypes
+	paInt mut_max_rep;                ///maximum allowed number of repetitions for the '#' repetition gene
 
 	SString excluded_modifiers;       ///<Modifiers that are excluded in mutation process
@@ -63,5 +72,5 @@
 	 * @return GENOOPER_OK if genotype is valid, GENOPER_REPAIR if genotype can be repaired, GENOPER_OPFAIL if genotype can't be repaired
 	 */
-	int  ValidateRec(f4_node *geno, int retrycount) const;
+	int  ValidateRec(f4_Node *geno, int retrycount) const;
 
 	/**
@@ -86,23 +95,36 @@
 	 * @return GENOPER_OK if mutation was performed successfully, GENOPER_FAIL otherwise
 	 */
-	int  MutateOne(f4_node *& g, int &method) const;
+	int  MutateOne(f4_Node *& g, int &method) const;
 
 	/**
-	 * Creates a random connection to an existing neuron or creates an additional
+	 * Finds all neurons in g (in the order of ordNode()) and returns their neuroclasses in a vector.
+	 * Additionally, looks for the needle_neuron node and returns its index (in the list of the returned vector) as found_index,
+	 * or -1 if not found (for example, it was not a neuroclass node or not added to the "g" tree).
+	 * @param g root node
+	 * @param needle_neuron neuroclass node to look for in all nodes
+	 * @param found_index returned index of needle
+	 * @return all nodes that are neurons
+	 */
+	static vector<NeuroClass*> findAllNeuronsAndNode(f4_Node * const & g, f4_Node* const &needle_neuron, int &found_index);
+
+	/**
+	 * Finds indexes of a given neuron and another random (output- or input-providing) neuron in the list of all neurons present in the "g" tree.
+	 * @param g root node
+	 * @param neuron neuroclass node to look for in all nodes in g
+	 * @param other_has_output if true, other neuron will provide output; otherwise, it will accept input(s)
+	 * @param neuron_index returned index of neuron
+	 * @param other_neuron_index returned index of a random neuron that provides an output or accepts inputs
+	 * @return true if succeeded, false otherwise
+	 */
+	static bool findConnectionNeuronIndexes(f4_Node * const &g, f4_Node *neuron, bool other_has_output, int &neuron_index, int &other_neuron_index);
+
+	/**
+	 * Creates a random connection to an existing neuron and randomizes connection weight
 	 * sensor for a neuron.
 	 * @param nn neuron class node
-	 * @param neuid id of a neuron
-	 * @param neulist list of genotype neuron classes
+	 * @param nn_index index of the nn neuron
+	 * @param other_index index of the neuron providing output, to get input from
 	 */
-	void linkNodeMakeRandom(f4_node *nn, int neuid, std::vector<NeuroClass*> neulist) const;
-
-	/**
-	 * Changes connection to an existing neuron or creates an additional
-	 * sensor for neuron.
-	 * @param nn neuron connection node
-	 * @param neuid id of a neuron
-	 * @param neulist list of genotype neuron classes
-	 */
-	void linkNodeChangeRandom(f4_node *nn, int neuid, std::vector<NeuroClass*> neulist) const;
+	void connectionNodeChangeRandom(f4_Node *nn, int nn_index, int other_index) const;
 
 	/**
@@ -110,5 +132,5 @@
 	 * @param nn neuron node
 	 */
-	void nparNodeMakeRandom(f4_node *nn) const;
+	void nparNodeMakeRandom(f4_Node *nn) const;
 
 	/**
@@ -116,5 +138,5 @@
 	 * @param nn repetition node
 	 */
-	void repeatNodeChangeRandom(f4_node *nn) const;
+	void repeatNodeChangeRandom(f4_Node *nn) const;
 
 	/**
@@ -124,5 +146,5 @@
 	 * @return GENOPER_OK if performed successful mutation, GENOPER_FAIL otherwise
 	 */
-	int  MutateOneValid(f4_node *&g, int &method) const;
+	int  MutateOneValid(f4_Node *&g, int &method) const;
 
 	/**
@@ -134,5 +156,5 @@
 	 * @param chg percentage of the first parent in offspring (the second parent has the rest)
 	 */
-	int  CrossOverOne(f4_node *g1, f4_node *g2, float chg) const;
+	int  CrossOverOne(f4_Node *g1, f4_Node *g2, float chg) const;
 };
 
